'From Squeak4.2 of 13 April 2011 [latest update: #11241] on 15 April 2011 at 5:57:11 am'!

!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'edc 4/15/2011 05:41'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint  onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerExtent: answerExtent
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."
	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	| aFillInTheBlankMorph |
	aFillInTheBlankMorph := self new
		setQuery: queryString
		initialAnswer: defaultAnswer
		answerExtent: answerExtent
		acceptOnCR: acceptBoolean.
	aFillInTheBlankMorph responseUponCancel: returnOnCancel.
	
	 aFillInTheBlankMorph center:aPoint ; openCenteredInWorld.
	^ aFillInTheBlankMorph getUserResponse
! !


!MCRepository class methodsFor: 'configuring' stamp: 'edc 4/15/2011 05:36'!
fillInTheBlankConfigure: aTemplateString
	| chunk repo |
	
	aTemplateString ifNil: [ ^ false ].
	chunk := UIManager default 
			request: self fillInTheBlankRequest
			initialAnswer: aTemplateString
			centerAt: Sensor cursorPoint
			onCancelReturn: nil
			acceptOnCR: false
			answerExtent: 400@120.
			
	chunk 
		ifNotNil: [ 
			repo := self readFrom: chunk readStream.
			repo creationTemplate: chunk. 
	].

	^ repo! !


!SMxFillInTheBlank class methodsFor: 'instance creation' stamp: 'edc 4/15/2011 05:49'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint  onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerExtent: answerExtent
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."

	^ self fillInTheBlankMorphClass
				request: queryString
				initialAnswer: defaultAnswer
				centerAt: aPoint
				onCancelReturn: nil
		acceptOnCR: false
		answerExtent: answerExtent! !


!SMxFillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'edc 4/15/2011 05:54'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint  onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerExtent: answerExtent
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."
	"SMxFillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	| aFillInTheBlankMorph |
	aFillInTheBlankMorph _ self new
		setQuery: queryString
		initialAnswer: defaultAnswer
		answerExtent: answerExtent
		acceptOnCR: acceptBoolean.
	aFillInTheBlankMorph responseUponCancel: returnOnCancel.
	 aFillInTheBlankMorph center:aPoint ; openCenteredInWorld.
	^ aFillInTheBlankMorph getUserResponse
! !


!UIManager methodsFor: 'ui requests' stamp: 'edc 4/15/2011 05:43'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint  onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerExtent: answerExtent

	^self subclassResponsibility! !


!MorphicUIManager methodsFor: 'ui requests' stamp: 'edc 4/15/2011 05:46'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint  onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerExtent: answerExtent
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."

	
	^FillInTheBlankMorph 
		request: queryString 
		initialAnswer: defaultAnswer 
		centerAt: aPoint 
		
		onCancelReturn: nil
		acceptOnCR: false
		answerExtent: answerExtent! !


!SimpleMorphicUIManager methodsFor: 'ui requests' stamp: 'edc 4/15/2011 05:52'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint  onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerExtent: answerExtent
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."

	^SMxFillInTheBlank request: queryString 
		initialAnswer: defaultAnswer 
		centerAt: aPoint 
		
		onCancelReturn: nil
		acceptOnCR: false
		answerExtent: answerExtent! !

